<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Schema;

class XCXApiController extends Controller
{
  public static $request;
  public static function Api($url_code)
  {
    $url = 'https://dqgatjzx-wx.sixinyun.com';
    $api['就诊人列表'] = "{$url}/PEISCommon/QueryCombos/460107000001";
    $api['订单支付'] = "{$url}/PEISCommon/QueryGroups";
    $api['订单查询'] = "{$url}/PEISCommon/QueryCombos";
    $api['订单退款'] = "{$url}/PEISCommon/QueryCombos";
    return $api["{$url_code}"] ?? $url_code;
  }
  public static function Post($url_code, $data)
  {
    $url = self::Api($url_code);
    self::RequestLog($url, $data, $url_code,'小程序接口');
    $response = Http::post($url,$data);
    if ($response->successful()) {
      // 处理成功的响应
      $res_string = json_encode($response->json(),JSON_UNESCAPED_UNICODE);
      $str_len = mb_strlen($res_string, 'utf-8');
      $str_size = $str_len / 1024;
      $save_res = $res_string;
      if ($str_size > 10) $save_res = '{"data":"Row size too large"}';
      self::$request->response_data = $save_res;
      self::$request->save();
    } else {
      // 处理失败的响应
      self::$request->response_data = "请求失败";
      self::$request->save();
    }
  }

  public static function RequestLog($url, $post_data, $mark ,$code=0)
  {
    self::CheckTableName();
    foreach ($post_data as $key => $post_datum) {
      $str_len = mb_strlen(json_encode($post_datum, JSON_UNESCAPED_UNICODE), 'utf-8');
      $str_size = $str_len / 1024;
      if ($str_size > 10) {
        $post_data["$key"] = 'Row size too large';
      }
    }
    $post_data = json_encode($post_data, JSON_UNESCAPED_UNICODE);
    self::$request->code = $code;
    self::$request->mark = $mark;
    self::$request->post_data = $post_data == '[]' ? '{}' : $post_data;
    self::$request->request_url = $url;
    self::$request->save();
  }

  public static function CheckTableName()
  {
    $table_name = 'zz_peis_log_' . date('ym');
    $table_count = DB::select('select count(1) as c from information_schema.TABLES where table_schema = ? and table_name = ?', [env('DB_DATABASE'), $table_name])[0];
    if ($table_count->c === 0) {
      Schema::create($table_name, function (Blueprint $table) {
        $table->id();
        $table->string('code', 50)->index();
        $table->string('mark', 50)->index();
        $table->text('post_data');
        $table->text('response_data')->nullable();
        $table->string('request_url', 300);
        $table->timestamps();
      });
    }
    self::$request = new \App\Models\PEISLog();
    self::$request->setTable($table_name);
  }
}
